diff --git a/game/client/src/main/java/net/minecraft/client/render/TextureManager.java b/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
index f41b3dc38..738044ccb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
@@ -14,6 +14,8 @@ import java.util.Map;
 import java.util.Objects;
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.popup.PopupScreen;
@@ -64,7 +66,7 @@ public class TextureManager {
 
 	public final Minecraft mc;
 
-	public final Map<Integer, Texture> idToTextureMap = new HashMap<>();
+	public final Int2ObjectMap<Texture> idToTextureMap = new Int2ObjectArrayMap<>();
 	public final Map<String, Texture> textureMap = new HashMap<>();
 	public final List<TextureBuffered> bufferedTextures = new ArrayList<>();
 	public final Map<String, TextureDownloaded> downloadedTextures = new HashMap<>();
@@ -267,22 +269,19 @@ public class TextureManager {
 			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
 			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
 		}
-		
-		byte[] bytes = new byte[w * h * 4];
+
+		buffer.clear();
 		for (int l = 0; l < imageData.length; l++) {
 			int a = imageData[l] >> 24 & 0xff;
 			int r = imageData[l] >> 16 & 0xff;
 			int g = imageData[l] >> 8 & 0xff;
 			int b = imageData[l] & 0xff;
-			bytes[l * 4] 	 = (byte) r;
-			bytes[l * 4 + 1] = (byte) g;
-			bytes[l * 4 + 2] = (byte) b;
-			bytes[l * 4 + 3] = (byte) a;
+			buffer.put(l * 4, (byte) r);
+			buffer.put(l * 4 + 1, (byte) g);
+			buffer.put(l * 4 + 2, (byte) b);
+			buffer.put(l * 4 + 3, (byte) a);
 		}
-
-		buffer.clear();
-		buffer.put(bytes);
-		buffer.position(0).limit(bytes.length);
+		buffer.position(0).limit(w * h * 4);
 		
 		glTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, w, h, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
 	}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
index 48144a44c..aff52d9ca 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
@@ -17,7 +17,7 @@ public class BlockModelBrazier<T extends BlockLogicBrazier>
     extends BlockModelStandard<T> {
     protected IconCoordinate sideTexture = TextureRegistry.getTexture("minecraft:block/brazier/side");
     protected IconCoordinate baseTexture = TextureRegistry.getTexture("minecraft:block/brazier/base");
-    protected BlockModelStandard<?> fireModel = new BlockModelFire<>(Blocks.FIRE, true).withTextures("minecraft:block/fire");
+    protected BlockModelStandard<?> fireModel = new BlockModelFire<>(Blocks.FIRE, true).setAllTextures(BLOCK_TEXTURES, "minecraft:block/fire");
 
     public BlockModelBrazier(Block<T> block) {
         super(block);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
index 1664cf66c..4c87b01d4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
@@ -19,7 +19,7 @@ public class BlockModelWireRedstone<T extends BlockLogic> extends BlockModelStan
     protected final IconCoordinate wireCross = TextureRegistry.getTexture("minecraft:block/wire_redstone_cross");
     public BlockModelWireRedstone(Block<T> block) {
         super(block);
-        withTextures("minecraft:block/wire_redstone_cross");
+        setAllTextures(BLOCK_TEXTURES, "minecraft:block/wire_redstone_cross");
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/customatlas/Atlas.java b/game/client/src/main/java/net/minecraft/client/render/customatlas/Atlas.java
index 81e5bded3..353a19cb9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/customatlas/Atlas.java
+++ b/game/client/src/main/java/net/minecraft/client/render/customatlas/Atlas.java
@@ -1,5 +1,7 @@
 package net.minecraft.client.render.customatlas;
 
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
 import org.jetbrains.annotations.NotNull;
 
 import java.io.BufferedReader;
@@ -46,7 +48,7 @@ public class Atlas {
 	public static Atlas read(final InputStream in) {
 		final Atlas atlas = new Atlas();
 		
-		final Map<Integer, AtlasTile> map = new HashMap<>();
+		final Int2ObjectMap<AtlasTile> map = new Int2ObjectOpenHashMap<>();
 		
 		BufferedReader br = null;
 		try {
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/Shader.java b/game/client/src/main/java/net/minecraft/client/render/shader/Shader.java
index 5def25de5..ef49ea328 100644
--- a/game/client/src/main/java/net/minecraft/client/render/shader/Shader.java
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/Shader.java
@@ -6,6 +6,8 @@ import java.util.HashMap;
 import java.util.Map;
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
+import it.unimi.dsi.fastutil.objects.Object2IntMap;
 import net.minecraft.client.render.OpenGLHelper;
 import org.slf4j.Logger;
 
@@ -18,7 +20,7 @@ public class Shader {
 	
 	private boolean enabled = false;
 	
-	private final Map<String, Integer> uniformLocations = new HashMap<>();
+	private final Object2IntMap<String> uniformLocations = new Object2IntArrayMap<>();
 	
 	public Shader compile(ShaderProvider folder, String name) {
 		if(name == null) throw new NullPointerException();
@@ -90,8 +92,8 @@ public class Shader {
 	}
 	
 	public int getUniform(String uniform) {
-		Integer location = uniformLocations.get(uniform);
-		if(location == null) {
+		int location = uniformLocations.getOrDefault(uniform, -1);
+		if(location == -1) {
 			location = glGetUniformLocation(program, uniform);
 			uniformLocations.put(uniform, location);
 		}
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/RegionBuffer.java b/game/client/src/main/java/net/minecraft/client/render/terrain/RegionBuffer.java
index 3da683cfd..af39ef45d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/RegionBuffer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/RegionBuffer.java
@@ -1,5 +1,8 @@
 package net.minecraft.client.render.terrain;
 
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+
 import java.util.ArrayList;
 import java.util.Collections;
 import java.util.HashMap;
@@ -10,7 +13,7 @@ public class RegionBuffer {
 	
 	public final int regionSizeShift;
 	
-	private final Map<Integer, RenderRegion> regionMap = new HashMap<>();
+	private final Int2ObjectMap<RenderRegion> regionMap = new Int2ObjectArrayMap<>();
 	private final List<RenderRegion> regionList = new ArrayList<>();
 	private final List<RenderRegion> immutableRegionList = Collections.unmodifiableList(regionList);
 	
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
index cdc633120..b43ec9b99 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
@@ -1,5 +1,7 @@
 package net.minecraft.client.render.tileentity;
 
+import it.unimi.dsi.fastutil.ints.IntArrayList;
+import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.LightmapHelper;
@@ -40,8 +42,8 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
 
     public TileEntityRendererSign() {
         super();
-        for (int i = 0; i < signColorTextures.length; i++) {
-            signColorTextures[i] = "/assets/minecraft/textures/entity/sign/" + DyeColor.colorFromBlockMeta(i).colorID + ".png";
+        for (int i = 0; i < this.signColorTextures.length; i++) {
+            this.signColorTextures[i] = "/assets/minecraft/textures/entity/sign/" + DyeColor.colorFromBlockMeta(i).colorID + ".png";
         }
     }
 
@@ -91,9 +93,9 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
 
         GL11.glPushMatrix();
         GL11.glScalef(scale, scale, -scale);
-        int colorSign;
+        final int colorSign;
         if (Block.hasLogicClass(block, BlockLogicSignPainted.class)) {
-            DyeColor c = ((IPainted) block.getLogic()).fromMetadata(meta);
+            final DyeColor c = ((IPainted) block.getLogic()).fromMetadata(meta);
             bindTexture(this.signColorTextures[c.blockMeta]);
             colorSign = c.color.getARGB();
         } else {
@@ -164,7 +166,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
         }
         final int _x = 0;
         final int _y = - tileEntity.signText.length * 5;
-        if (tileEntity.isGlowing() && mc.gameSettings.fancyGraphics.value >= 1) {
+        if (tileEntity.isGlowing() && this.mc.gameSettings.fancyGraphics.value >= 1) {
             this.textMeshRenderer.render(sr, t, line1, line2, line3, line4, _x, _y, SF.setOutlined(SF.setColor(0, color)));
         } else {
             this.textMeshRenderer.render(sr,t, line1, line2, line3, line4, _x, _y, SF.setColor(0, color));
@@ -177,7 +179,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
         GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
 
-    private static void drawTexturedModalRect(final double width, final double height, int color, final @NotNull IconCoordinate coordinate)
+    private static void drawTexturedModalRect(final double width, final double height, final int color, final @NotNull IconCoordinate coordinate)
     {
         coordinate.parentAtlas.bind();
         final Tessellator tessellator = Tessellator.instance;
@@ -207,7 +209,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
 
     public static class BufferedTextMeshRenderer {
         private static final long MAX_NON_RENDERED_TIME = 120 * 1000;
-        private final @NotNull List<@NotNull Integer> freeDisplayLists = new ArrayList<>();
+        private final @NotNull IntList freeDisplayLists = new IntArrayList();
         private final @NotNull List<@NotNull MeshEntry> bufferedMeshes = new ArrayList<>();
 
         private final @NotNull MeshEntry referenceEntry = new MeshEntry("", "", "", "", 0);
@@ -225,14 +227,14 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
         }
 
         public void flushCaches() {
-            for (MeshEntry entry : bufferedMeshes) {
+            for (final MeshEntry entry : this.bufferedMeshes) {
                 GLAllocation.deleteDisplayList(entry.list);
             }
-            bufferedMeshes.clear();
-            for (Integer list : freeDisplayLists) {
+            this.bufferedMeshes.clear();
+            for (final int list : this.freeDisplayLists) {
                 GLAllocation.deleteDisplayList(list);
             }
-            freeDisplayLists.clear();
+            this.freeDisplayLists.clear();
         }
 
         public void render(@NotNull final FontRenderer sr,
@@ -296,7 +298,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
             if (this.freeDisplayLists.isEmpty()) {
                 return GLAllocation.generateDisplayLists(1);
             } else {
-                return this.freeDisplayLists.remove(0);
+                return this.freeDisplayLists.removeInt(0);
             }
         }
 
diff --git a/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java b/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
index 62b0c16da..063c8600f 100644
--- a/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
@@ -7,6 +7,8 @@ import java.util.HashSet;
 import java.util.List;
 import java.util.Set;
 
+import it.unimi.dsi.fastutil.ints.IntArraySet;
+import it.unimi.dsi.fastutil.ints.IntSet;
 import org.lwjgl.input.Keyboard;
 
 import net.minecraft.client.Minecraft;
@@ -26,7 +28,7 @@ public class ItemDragHandler extends Gui {
 	private int renderOffsetX;
 	private int renderOffsetY;
 	
-	private Set<Integer> cancelRelease = new HashSet<>();
+	private IntSet cancelRelease = new IntArraySet();
 	
 	///////////////////////
 	
diff --git a/game/client/src/main/java/net/minecraft/client/util/helper/Textures.java b/game/client/src/main/java/net/minecraft/client/util/helper/Textures.java
index 0772c6fcf..7094b1476 100644
--- a/game/client/src/main/java/net/minecraft/client/util/helper/Textures.java
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/Textures.java
@@ -17,6 +17,7 @@ import java.util.List;
 import javax.imageio.ImageIO;
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.client.render.texture.stitcher.AtlasStitcher;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.util.helper.Buffer;
@@ -121,10 +122,10 @@ public class Textures {
 		OpenGLHelper.checkError("pre texture dump");
 
 		LOGGER.info("Dump Textures...");
-		
-		List<Integer> textureList = GLAllocation.textureNames;
+
+		IntList textureList = GLAllocation.textureNames;
 		for(int i=0; i < textureList.size(); i++) {
-			Integer tex = textureList.get(i);
+			Integer tex = textureList.getInt(i);
 
             LOGGER.debug("Tex: {}", tex);
 			
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java b/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
index cdba02ffa..c0f4a482f 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
@@ -1,12 +1,14 @@
 package net.minecraft.client.world;
 
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
 import net.minecraft.client.net.handler.PacketHandlerClient;
 import net.minecraft.client.world.chunk.provider.ChunkProviderClient;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.net.packet.PacketDisconnect;
-import net.minecraft.core.util.collection.IntHashMap;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
@@ -20,7 +22,7 @@ public class WorldClientMP extends WorldClient {
     private final LinkedList<WorldBlockPositionType> positionTypesList;
     private final PacketHandlerClient sendQueue;
     private ChunkProviderClient chunkCache;
-    private final IntHashMap<Entity> entitiesById;
+    private final Int2ObjectMap<Entity> entitiesById;
     private final Set<Entity> forced;
     private final Set<Entity> reEntries;
 
@@ -28,7 +30,7 @@ public class WorldClientMP extends WorldClient {
     {
         super(new SaveHandlerClientMP(), "MpServer", Dimension.getDimensionList().get(dimensionId), Registries.WORLD_TYPES.getItemByNumericId(worldTypeId), seed);
         positionTypesList = new LinkedList<>();
-        entitiesById = new IntHashMap<>();
+        entitiesById = new Int2ObjectOpenHashMap<>();
         forced = new HashSet<>();
         reEntries = new HashSet<>();
         sendQueue = packetHandlerClient;
diff --git a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderDynamic.java b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderDynamic.java
index 00dd4f354..da3815398 100644
--- a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderDynamic.java
+++ b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderDynamic.java
@@ -1,6 +1,10 @@
 package net.minecraft.client.world.chunk.provider;
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
+import it.unimi.dsi.fastutil.ints.IntArraySet;
+import it.unimi.dsi.fastutil.ints.IntSet;
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.world.ProgressListener;
 import net.minecraft.core.world.World;
@@ -15,12 +19,12 @@ import java.util.*;
 public class ChunkProviderDynamic implements IChunkProvider
 {
     private static final Logger LOGGER = LogUtils.getLogger();
-    private final Set<Integer> droppedChunksSet;
+    private final IntSet droppedChunksSet;
     private final Chunk emptyChunk;
     public ChunkGenerator chunkGenerator;
     private final IChunkLoader chunkLoader;
-    private final Map<Integer, Chunk> chunkMap;
-    private final Map<Integer, Chunk> forceLoadedChunkMap;
+    private final Int2ObjectMap<Chunk> chunkMap;
+    private final Int2ObjectMap<Chunk> forceLoadedChunkMap;
     private final List<Chunk> forceLoadedChunkList;
     private final World world;
     private int currentChunkX;
@@ -33,10 +37,10 @@ public class ChunkProviderDynamic implements IChunkProvider
 
     public ChunkProviderDynamic(World world, IChunkLoader chunkLoader, ChunkGenerator chunkGenerator)
     {
-        droppedChunksSet = new HashSet<>();
-        chunkMap = new HashMap<>();
+        droppedChunksSet = new IntArraySet();
+        chunkMap = new Int2ObjectOpenHashMap<>();
         forceLoadedChunkList = new ArrayList<>();
-        forceLoadedChunkMap = new HashMap<>();
+        forceLoadedChunkMap = new Int2ObjectOpenHashMap<>();
         emptyChunk = new EmptyChunk(world, 0, 0);
         this.world = world;
         this.chunkLoader = chunkLoader;
@@ -253,7 +257,7 @@ public class ChunkProviderDynamic implements IChunkProvider
         }
         if(!droppedChunksSet.isEmpty()){
             int unloaded = 0;
-            HashSet<Integer> copy = new HashSet<>(droppedChunksSet);
+            IntSet copy = new IntArraySet(droppedChunksSet);
             for (int i : copy) {
                 if(unloaded >= maxUnloadPerTick) break;
                 if(forceLoadedChunkMap.containsKey(i)) continue;
diff --git a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java
index affc2f3fa..4454f7bee 100644
--- a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java
+++ b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java
@@ -12,6 +12,8 @@ import com.google.gson.JsonSerializationContext;
 import com.google.gson.JsonSerializer;
 import com.google.gson.stream.JsonReader;
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
+import it.unimi.dsi.fastutil.objects.Object2IntMap;
 import net.minecraft.client.render.texturepack.TexturePackList;
 import net.minecraft.core.util.HardIllegalArgumentException;
 import net.minecraft.core.util.collection.NamespaceID;
@@ -93,7 +95,7 @@ public class BlockModelMojangData implements BlockModelData {
     /**
      * Each direction's color index, -1 represents no color
      */
-    public final @Nullable Map<@NotNull Direction, @NotNull Integer> particleIndices;
+    public final @Nullable Object2IntMap<@NotNull Direction> particleIndices;
 
     /**
      * Contains all the elements of the model.
@@ -109,7 +111,7 @@ public class BlockModelMojangData implements BlockModelData {
         @Nullable final Integer renderLayer,
         @Nullable final Map<@NotNull String, @NotNull DisplayPos> displayPositions,
         @Nullable final Map<@NotNull String, @NotNull String> textures,
-        @Nullable final Map<@NotNull Direction, @NotNull Integer> particleIndices,
+        @Nullable final Object2IntMap<@NotNull Direction> particleIndices,
         @Nullable final List<@NotNull Element> elements)
     {
         this.modelId = id.makePermanent();
@@ -120,7 +122,7 @@ public class BlockModelMojangData implements BlockModelData {
             if (parentData != null) {
                 this.displayPositions = new HashMap<>();
                 this.textures = new HashMap<>();
-                this.particleIndices = new HashMap<>();
+                this.particleIndices = new Object2IntArrayMap<>();
                 // Elements overrides parent's elements rather than merges them like other fields
                 this.elements = (parentData.elements != null && elements == null) ? new ArrayList<>(parentData.elements) : elements;
                 this.renderLayer = (parentData.renderLayer != null && renderLayer == null) ? parentData.renderLayer : renderLayer;
@@ -179,7 +181,7 @@ public class BlockModelMojangData implements BlockModelData {
         protected int renderLayer = DEFAULT_RENDER_LAYER;
         protected @Nullable Map<@NotNull String, @NotNull DisplayPos> displayPosMap = null;
         protected @Nullable Map<@NotNull String, @NotNull String> textures = null;
-        protected @Nullable Map<@NotNull Direction, @NotNull Integer> particleIndices = null;
+        protected @Nullable Object2IntMap<@NotNull Direction> particleIndices = null;
         protected @Nullable List<Element. @NotNull Builder> elements = null;
 
         public @NotNull Builder setParent(@Nullable final String parent) {
@@ -231,8 +233,8 @@ public class BlockModelMojangData implements BlockModelData {
             return this.textures;
         }
 
-        private @NotNull Map<@NotNull Direction, @NotNull Integer> prepareParticleIndicesMap() {
-            if (this.particleIndices == null) this.particleIndices = new HashMap<>();
+        private @NotNull Object2IntMap<@NotNull Direction> prepareParticleIndicesMap() {
+            if (this.particleIndices == null) this.particleIndices = new Object2IntArrayMap<>();
             return this.particleIndices;
         }
 
diff --git a/game/core/build.gradle.kts b/game/core/build.gradle.kts
index 926dc3843..6b45882d5 100644
--- a/game/core/build.gradle.kts
+++ b/game/core/build.gradle.kts
@@ -34,6 +34,7 @@ dependencies {
     // <core dependencies>
     implementation(libs.jetbrains.annotations)
     implementation(libs.gson)
+    implementation(libs.fastutil)
     implementation(libs.brigadier)
     implementation(libs.bundles.log4j)
     implementation(project(":util:nbt"))
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatList.java b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatList.java
index ef3e4c5c3..fc6feae96 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatList.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatList.java
@@ -1,5 +1,9 @@
 package net.minecraft.core.achievement.stat;
 
+import it.unimi.dsi.fastutil.ints.Int2IntMap;
+import it.unimi.dsi.fastutil.ints.Int2IntOpenHashMap;
+import it.unimi.dsi.fastutil.ints.IntOpenHashSet;
+import it.unimi.dsi.fastutil.ints.IntSet;
 import net.minecraft.core.WeightedRandomBag;
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.achievement.Achievements;
@@ -82,7 +86,7 @@ public abstract class StatList
 
     public static Map<NamespaceID, Stat> mobEncounterStats;
 
-    public static Map<Integer, Integer> replacementMap = new HashMap<>();
+    public static Int2IntMap replacementMap = new Int2IntOpenHashMap();
 
     public StatList()
     {
@@ -106,7 +110,7 @@ public abstract class StatList
         initReplaceMap();
         Achievements.init();
 
-        HashSet<Integer> craftable = new HashSet<>();
+        IntSet craftable = new IntOpenHashSet();
         for (RecipeEntryCrafting<?,?> r : Registries.RECIPES.getAllCraftingRecipes()){
             if (r.getOutput() instanceof ItemStack){
                 craftable.add(((ItemStack) r.getOutput()).itemID);
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java
index 4c56e4622..74af0d48f 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java
@@ -14,24 +14,28 @@ import com.b100.json.element.JsonEntry;
 import com.b100.json.element.JsonObject;
 import com.b100.utils.FileUtils;
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.objects.Object2IntMap;
+import it.unimi.dsi.fastutil.objects.Object2IntMaps;
+import it.unimi.dsi.fastutil.objects.Object2IntOpenHashMap;
 import net.minecraft.core.MD5String;
 import net.minecraft.core.achievement.Achievement;
 import net.minecraft.core.player.Session;
 import net.minecraft.core.util.HardIllegalArgumentException;
 import net.minecraft.core.util.collection.NamespaceID;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Unmodifiable;
 import org.slf4j.Logger;
 
 public class StatsCounter {
 	private static final Logger LOGGER = LogUtils.getLogger();
-	private final Map<Stat, Integer> sessionStats; // Local copy of stats used by the client
-	private final Map<Stat, Integer> savedStats;
+	private final Object2IntMap<Stat> sessionStats; // Local copy of stats used by the client
+	private final Object2IntMap<Stat> savedStats;
 	private boolean modified;
 	private final StatsSyncher statsSyncher;
 
 	public StatsCounter(Session session, File mcDir) {
-		sessionStats = new HashMap<>();
-		savedStats = new HashMap<>();
+		sessionStats = new Object2IntOpenHashMap<>();
+		savedStats = new Object2IntOpenHashMap<>();
 		modified = false;
 		
 		File statsFolder = new File(mcDir, "stats");
@@ -48,46 +52,46 @@ public class StatsCounter {
 		modified = true;
 	}
 
-	private void addToMap(Map<Stat, Integer> map, Stat stat, int amount) {
+	private void addToMap(Object2IntMap<Stat> map, Stat stat, int amount) {
 		int currentValue = map.getOrDefault(stat, 0);
 		map.put(stat, currentValue + amount);
 	}
 
 	@Unmodifiable
-	public Map<Stat, Integer> getSavedStats() {
-		return Collections.unmodifiableMap(savedStats);
+	public Object2IntMap<Stat> getSavedStats() {
+		return Object2IntMaps.unmodifiable(savedStats);
 	}
 
-	public void addToBoth(Map<Stat, Integer> changes) {
+	public void addToBoth(Object2IntMap<Stat> changes) {
 		if(changes == null) {
 			return;
 		}
 		modified = true;
 		for (Stat stat : changes.keySet()) {
-			addToMap(savedStats, stat, changes.get(stat));
-			addToMap(sessionStats, stat, changes.get(stat));
+			addToMap(savedStats, stat, changes.getInt(stat));
+			addToMap(sessionStats, stat, changes.getInt(stat));
 		}
 
 	}
 
-	public void addToLocal(Map<Stat, Integer> changes) {
+	public void addToLocal(Object2IntMap<Stat> changes) {
 		if(changes == null) {
 			return;
 		}
 		for (Stat stat : changes.keySet()) {
 			int currentValue = savedStats.getOrDefault(stat, 0);
-			sessionStats.put(stat, currentValue + changes.get(stat));
+			sessionStats.put(stat, currentValue + changes.getInt(stat));
 		}
 
 	}
 
-	public void addToSaved(Map<Stat, Integer> map) {
+	public void addToSaved(Object2IntMap<Stat> map) {
 		if(map == null) {
 			return;
 		}
 		modified = true;
 		for (Stat stat : map.keySet()) {
-			addToMap(savedStats, stat, map.get(stat));
+			addToMap(savedStats, stat, map.getInt(stat));
 		}
 	}
 
@@ -143,8 +147,8 @@ public class StatsCounter {
 		}
 	}
 
-	public static Map<Stat, Integer> readStatsFromString(String jsonString) {
-		Map<Stat, Integer> map = new HashMap<>();
+	public static @NotNull Object2IntMap<Stat> readStatsFromString(String jsonString) {
+		Object2IntMap<Stat> map = new Object2IntOpenHashMap<>();
 		try {
 			JsonParser parser = new JsonParser();
 			JsonObject rootObject = parser.parseString(jsonString);
@@ -182,7 +186,7 @@ public class StatsCounter {
 		return map;
 	}
 
-	public static String getStatFileContentString(UUID uuid, String sessionID, Map<Stat, Integer> map) {
+	public static String getStatFileContentString(UUID uuid, String sessionID, Object2IntMap<Stat> map) {
 		StringBuilder displayString = new StringBuilder();
 		StringBuilder checkSumString = new StringBuilder();
 		boolean flag = true;
@@ -202,10 +206,10 @@ public class StatsCounter {
 			} else {
 				flag = false;
 			}
-			displayString.append("\r\n    {\"").append(statbase.statId).append("\":").append(map.get(statbase));
+			displayString.append("\r\n    {\"").append(statbase.statId).append("\":").append(map.getInt(statbase));
 
 			checkSumString.append(statbase.statId).append(","); // Used to use UUID rather than namespace
-			checkSumString.append(map.get(statbase)).append(",");
+			checkSumString.append(map.getInt(statbase)).append(",");
 		}
 
 		if (!flag) {
